<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004-2005 Marc "Waccoon" Leveille, http://www.NineChime.com/Wacintosh.htm
Version 1.1.5 - Last modified 3/15/2005
*/


// Debug prevents deletion of work files
$debug = 0;


include('common.php');


if ($_REQUEST['language'] == '') {
	$inst_language = 'english';
	$url_language = 'english';
	include('language/english.php');
} else {
	$inst_language = $_REQUEST['language'];
	$url_language = urlencode($inst_language);
	include('language/'.$inst_language.'.php');
}


// *** BEGIN HTML ***
echo <<<EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title>$langop_install_title</title>

	<meta http-equiv="Content-Type" content="text/html; charset=$charset">

	<link rel="stylesheet" type="text/css" href="templates/Install.css" title="Installer">
</head>

<body>



EOF;


// Waccoon: Test main dir permissions
if (!is_writable('.')) {
echo <<<EOF
	<p>
		$langop_install_error<br />
	</p>

</body>
</html>
EOF;
//<?
	exit;
}


// Confirmation for delete database
if ($_GET['mode'] == 'del') {
echo <<<EOF
	<h1 class="title">
		Delete database
	</h1>

	<hr />



EOF;
//<?

	if (check_file('dbconn.php') && check_file('config.php')) {
		include('config.php');

	if ($BBStitle == '') $BBStitle = '[ Unnamed, Data Prefix="'.$OekakiPoteto_Prefix.'", Member Prefix="'.$OekakiPoteto_MemberPrefix.'" ]';

echo <<<EOF
	<h2 class="header">
		Uninstall the OekakiPoteto database?
	</h2>

	<div class="infotable">
		<p class="infonote">
			Are you sure you want to remove the database?  This will remove information for the board "$BBStitle".  Pictures, templates, and all other files in the OP directory must be deleted manually.<br />
			<br />
			If you are not using different member databases for all your boards, only the board "$BBStitle" will be removed.  Other boards must be removed with their respective installers.<br />
			<br />
			<i>WARNING:</i>  If all your boards share the same member database, removing the profiles will destroy ALL member registrations, chat, and mailboxes for ALL your boards!<br />
		</p>

		<form action="install.php" method="post" class="infonote">
			<input name="action" type="hidden" value="db_delete" />

			<input name="db_prefix" type="checkbox" />Delete main database.<br />
			<input name="db_members" type="checkbox" />Delete member profiles, chat, and mailboxes.<br />
			<br />
			<input name="submit" type="submit" value="Delete" />

			<input name="language" type="hidden" value="$inst_language" />
		</form>
	</div>
</body>
</html>
EOF;
//<?

		exit;

	} else {

echo <<<EOF
	<h2 class="header">
		Uninstall error
	</h2>

	<div class="infotable">
		<p class="infonote">
			Valid database and config files were not found.  The board must be properly installed before any database entries can be removed.  If problems persist, let your sysadmin delete the databases by name.
		</p>
	</div>
</body>
</html>
EOF;
//<?

		exit;
	}
}


// Delete database
//
if ($_POST['action'] == 'db_delete') {
	include('dbconn.php');
	include('config.php');
	$delete_flag = 0;

echo <<<EOF
	<h1 class="title">
		Delete database
	</h1>

	<hr />


	<h2 class="header">
		Uninstall Status
	</h2>

	<div class="infotable">
		<p>

EOF;
//<?

	if ($_POST['db_prefix'] != '' && $debug == 0) {
		$result = mysql_query("DROP TABLE ".$OekakiPoteto_Prefix."oekakicmt");
		sql_check($result);
		$result = mysql_query("DROP TABLE ".$OekakiPoteto_Prefix."oekakidta");
		sql_check($result);
		$result = mysql_query("DROP TABLE ".$OekakiPoteto_Prefix."oekakimisc");
		sql_check($result);

		$delete_flag = 1;
	}

	if ($_POST['db_members'] != '' && $debug == 0) {
		$result = mysql_query("DROP TABLE ".$OekakiPoteto_MemberPrefix."oekaki");
		sql_check($result);
		$result = mysql_query("DROP TABLE ".$OekakiPoteto_MemberPrefix."oekakichat");
		sql_check($result);
		$result = mysql_query("DROP TABLE ".$OekakiPoteto_MemberPrefix."oekakichatmod");
		sql_check($result);
		$result = mysql_query("DROP TABLE ".$OekakiPoteto_MemberPrefix."oekakichatmodusers");
		sql_check($result);
		$result = mysql_query("DROP TABLE ".$OekakiPoteto_MemberPrefix."oekakionline");
		sql_check($result);
		$result = mysql_query("DROP TABLE ".$OekakiPoteto_MemberPrefix."oekakikill");
		sql_check($result);
		$result = mysql_query("DROP TABLE ".$OekakiPoteto_MemberPrefix."oekakimailbox");
		sql_check($result);

		$delete_flag = 1;
	}

	mysql_close($dbconn);
?>
		</p>

<? if ($delete_flag == 1) { ?>
		<p>
			<?=$langop_install_dbremove?> 
		</p>
<? } else { ?>
		<p>
			NOTE:  No databases changed
		</p>
<? } ?>

		<p>
			<a href="install.php">Return to the installer</a>
		</p>
	</div>

</body>
</html>
<?
	exit;
}


//
// User submits information (Yes, this is different from the control panel)
if ($_POST['Submit'] == 'Submit') {

	// Check all posts
	foreach ($_POST as $key=>$value) {
		$_POST[$key] = trim (slashit ($_POST[$key]));
	}


echo <<<EOF
	<h1 class="title">
		Wacintaki Poteto Installation
	</h1>

	<hr />


	<h2 class="header">
		Installation Progress
	</h2>

	<div class="infotable">
		<p>

EOF;
//<?


	// Verify input
	$OekakiPoteto_Prefix = $_POST['dbprefix'];
	$OekakiPoteto_MemberPrefix = $_POST['OekakiPoteto_MemberPrefix'];
	$pass    = $_POST['pass'];
	$pass2   = $_POST['pass2'];
	$saltenc = $_POST['saltstr'];
	$usrname = $_POST['usrname'];
	$input_fail = 0;

	if ($_POST['dbhost'] == '' || $_POST['dbuser'] == '' || $_POST['dbpass'] == '' || $_POST['dbname'] == '' ) {
		web_line('ERROR:  Your database settings are invalid.');
		$input_fail = 1;
	}
	if ($usrname == '') {
		web_line('ERROR:  The administrator login name is missing.');
		$input_fail = 1;
	}
	if ($pass == '' || $pass2 == '') {
		web_line('ERROR:  The administrator password is missing.');
		$input_fail = 1;
	}
	if ($pass != $pass2) {
		web_line('ERROR:  The administrator passwords do not match.');
		$input_fail = 1;
	}
	if ($saltenc == '') {
		web_line('ERROR:  You cannot omit the encryption key.');
		$input_fail = 1;
	}
	if ($input_fail == 1) {
echo <<<EOF
		</p>
	</div>
</body>
</html>
EOF;
		exit;
	}


// Create a database connection file from POST data.
$db_configuration = <<<EOF
<?php // Include only

	\$dbhost = '{$_POST['dbhost']}';
	\$dbuser = '{$_POST['dbuser']}';
	\$dbpass = '{$_POST['dbpass']}';
	\$dbname = '{$_POST['dbname']}';
	\$OekakiPoteto_Prefix = '{$_POST['dbprefix']}';
	\$OekakiPoteto_MemberPrefix = '{$_POST['OekakiPoteto_MemberPrefix']}';

	\$dbconn = mysql_connect(\$dbhost, \$dbuser, \$dbpass) or die('Could not connect to the MySQL database.');
	\$mySQLDB = mysql_select_db(\$dbname);

?>
EOF;
//<?

	// Create a configuration file from POST data.
	// Verify paths
	$_POST['okurl'] = strip_path($_POST['okurl']);
	$OPpics = strip_path($_POST['OPpics']);
	if (empty ($OPpics)) {
		$OPpics = 'pictures';
	}
	$_POST['OPPrefix']   = strip_path($_POST['OPPrefix']);
	$_POST['previewImg'] = strip_path($_POST['previewImg']);
	$_POST['pornImg']    = strip_path($_POST['pornImg']);

	// Slashit
	$_POST['BBStitle']  = slashit ($_POST['BBStitle']);
	$_POST['BBSauthor'] = slashit ($_POST['BBSauthor']);
	$_POST['eaddr']     = slashit ($_POST['eaddr']);

	// #@!*'n magic quotes!
	$the_title = preg_replace('/\\\"/', '&quot;', $_POST['BBStitle']);
	$the_author = preg_replace('/\\\"/', '&quot;', $_POST['BBSauthor']);

	// Other verification
	$drawaccess      = 'no';
	$animationaccess = 'no';
	$uploadaccess    = 'no';
	if (!empty ($_POST['drawaccess'])) $drawaccess = 'yes';
	if (!empty ($_POST['animationaccess'])) $animationaccess = 'yes';
	if (!empty ($_POST['uploadaccess'])) $uploadaccess = 'yes';

	// Verify min/max values
	{
		$verify     = array ('pstore', 'ppage', 'perpage', 'xDefault', 'yDefault', 'xCanvas', 'yCanvas', 'xMin', 'yMin', 'aCanvas', 'anisize', 'thumbBytes', 'thumbT', 'thumbR', 'max_upload');
		$verify_min = array (10, 1, 5, 50, 50, 50, 50, 50, 50, 2500, 1000, 25000, 50, 50, 100000);
		$verify_max = array (10000, 50, 500, 10000, 10000, 10000, 10000, 500, 500, 100000000, 1000000, 15000000, 500, 1000, 2000000);

		$i = 0;
		foreach ($verify as $name) {
			if ($_POST[$name] < $verify_min[$i]) $_POST[$name] = $verify_min[$i];
			if ($_POST[$name] > $verify_max[$i]) $_POST[$name] = $verify_max[$i];
			$i++;
		}
	}

	$main_configuration = <<<EOF
<?php // Include only

	\$CFG_version = 'wac-1.1.1';

	\$BBStitle  = '$the_title';
	\$BBSauthor = '$the_author';
	\$BBSadult  = '{$_POST['BBSadult']}';
	\$eaddr     = '{$_POST['eaddr']}';
	\$okurl     = '{$_POST['okurl']}';

	\$saltenc    = '{$saltenc}';
	\$OPpics     = '{$OPpics}';
	\$archivedir = '';
	\$OPPrefix   = '{$_POST['OPPrefix']}';

	\$killuser   = '{$_POST['killuser']}';
	\$killreg    = '-1'; //WIP
	\$approval   = '{$_POST['approval']}';
	\$requireart = '{$_POST['requireart']}';
	\$guestpost  = '{$_POST['guestpost']}';
	\$guestdraw  = 'no'; //WIP
	\$guestadult = '{$_POST['guestadult']}';
	\$drawaccess = '$drawaccess';
	\$animationaccess = '$animationaccess';
	\$uploadaccess  = '$uploadaccess';
	\$use_reg_rules = '{$_POST['use_reg_rules']}';

	\$language     = '{$_POST['languagesel']}';
	\$template     = '{$_POST['template']}';
	\$templatepath = 'templates';
	\$resourcepath = 'resource';

	\$pstore   = '{$_POST['pstore']}';
	\$ppage    = '{$_POST['ppage']}';
	\$perpage  = '{$_POST['perpage']}';
	\$picLimit     = '2';  //WIP
	\$picLimitTime = '24'; //WIP

	\$CFG_pornImg      = '{$_POST['pornImg']}';
	\$CFG_previewImg   = '{$_POST['previewImg']}';
	\$CFG_previewTitle = '{$_POST['previewTitle']}';
	\$xDefault = '{$_POST['xDefault']}';
	\$yDefault = '{$_POST['yDefault']}';
	\$xCanvas  = '{$_POST['xCanvas']}';
	\$yCanvas  = '{$_POST['yCanvas']}';
	\$xMin     = '{$_POST['xMin']}';
	\$yMin     = '{$_POST['yMin']}';
	\$aCanvas  = '{$_POST['aCanvas']}';
	\$anisize  = '{$_POST['anisize']}';
	\$max_upload = '{$_POST['max_upload']}';

	\$useThumb   = '{$_POST['useThumb']}';
	\$forceThumb = '{$_POST['forceThumb']}';
	\$thumbBytes = '{$_POST['thumbBytes']}';
	\$thumbT     = '{$_POST['thumbT']}';
	\$thumbR     = '{$_POST['thumbR']}';
	\$thumbJPG   = '75'; //WIP
	\$jpgcompression   = 'no'; //WIP
	\$jpgcompressqual  = '85'; //WIP

	\$useMailbox = '{$_POST['useMailbox']}';

	\$useChat  = '{$_POST['useChat']}';
	\$chatMax  = '{$_POST['chatMax']}';
	\$chatDisp = '{$_POST['chatDisp']}';

	\$useSuggest     = 'no'; //WIP
	\$suggestMax     = '50'; //WIP
	\$suggestApprove = 'no'; //WIP
?>
EOF;
//<?


	// Write the config files
	$fp = @fopen ('dbconn.php', 'w');
	if ($fp) {
		fwrite ($fp, $db_configuration);
		fclose ($fp);
		web_line('Wrote database config file...');
	} else {
		web_line('ERROR:  Could not open database config file for writing.  Check your server permissions');
echo <<<EOF
		</p>
	</div>
</body>
</html>
EOF;
//<?

		exit;
	}


	$fp = @fopen ('config.php', 'w');
	if ($fp) {
		fwrite ($fp, $main_configuration);
		fclose ($fp);
		web_line('Wrote config file...');
	} else {
echo <<<EOF
			ERROR:  Could not open config file for writing.  Check your server permissions.
		</p>
	</div>
</body>
</html>
EOF;
//<?

		exit;
	}


	/* Create specified directories with their respective permissions */
	if (! file_exists($OPpics)) {
		if (! @mkdir($OPpics, 0755)) {
			web_line('ERROR:  Could not create folder <em>'.$OPpics.'</em>');
		}
	}
	if (! is_writable($OPpics)) {
		web_line('ERROR:  Folder <em>'.$OPpics.'</em> is locked.  You may have to create this folder manually.');
	}


	/* CHMOD files... disabled b/c of restrictions some servers may have
	chmod ('resource/banner.php', 0666);
	chmod ('resource/notice.php', 0666);
	chmod ('resource/ips.txt', 0666);
	chmod ('resource/hosts.txt', 0666);
	chmod ('resource/rules.php', 0666);
	chmod ('version.php', 0666);
	*/


	/* Insert the fields into the database */
	web_line('Starting to set up database...');

	include('dbconn.php');
	include('config.php');

	$passenc = crypt($pass, $saltenc);

	if ($debug == 0) {
		{
			// Oekaki v1.0.0
			$sql = "CREATE TABLE {$OekakiPoteto_MemberPrefix}oekaki (ID int(11) NOT NULL auto_increment, usrname varchar(255) NOT NULL default '', usrpass text, usrflags varchar(10) default 'G', email varchar(255) default NULL, name varchar(25) default NULL, comment text, url text, aim varchar(30) default NULL, icq varchar(20) default NULL, urltitle text, joindate date NOT NULL default '0000-00-00', lastlogin datetime NOT NULL default '0000-00-00 00:00:00', MSN text, Yahoo text, IRCNick text, IRCServer text, location text, piccount int(11) NOT NULL default '0', IRCchan text, templatesel varchar(255) default '$template', commcount int(11) NOT NULL default '0', age text, gender text, picview tinyint(11) NOT NULL default '0', language TEXT, ";

			// Oekaki v1.1.0
			$sql .= "thumbview TINYINT NOT NULL DEFAULT 0, screensize MEDIUMINT NOT NULL DEFAULT 800, ";
			$sql .= "PRIMARY KEY (ID), UNIQUE KEY usrname (usrname))";

			$result = mysql_query($sql);
			sql_check($result, 'members');
		}

		$sqlstr = "INSERT INTO ".$OekakiPoteto_MemberPrefix."oekaki (ID, usrname, usrpass, usrflags, email, name, comment, joindate, language) VALUES ('', '$usrname', '$passenc', 'GASODMIU', 'your@email.com', 'Administrator', 'Administrator Account', CURDATE(),'$language')";
		$result = mysql_query($sqlstr);
		sql_check($result, 'admin');

		$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakichat (ChatID int(11) NOT NULL auto_increment, usrname varchar(255) NOT NULL default '', comment tinytext NOT NULL, posttime timestamp(14) NOT NULL, hostname text NOT NULL, email varchar(255) default NULL, url text, IP text NOT NULL, postname varchar(50) NOT NULL default '', PRIMARY KEY  (ChatID))");
		sql_check($result, 'chat');

		$result = mysql_query("CREATE TABLE ".$OekakiPoteto_Prefix."oekakicmt (ID_3 int(11) NOT NULL auto_increment, PIC_ID varchar(11) NOT NULL default '', usrname varchar(255) NOT NULL default '', comment text NOT NULL, postdate datetime default NULL, hostname text NOT NULL, email varchar(255) default NULL, url text, IP text NOT NULL, postname varchar(50) NOT NULL default '', PRIMARY KEY  (ID_3), KEY PIC_ID (PIC_ID))"); 
		sql_check($result, 'comment');

		{
			// OekakiData v1.0.0
			$sql = "CREATE TABLE ".$OekakiPoteto_Prefix."oekakidta (ID_2 int(11) NOT NULL auto_increment, PIC_ID int(11) NOT NULL default '', usrname varchar(255) NOT NULL default '', comment text NOT NULL, postdate datetime NOT NULL default '0000-00-00 00:00:00', hostname text NOT NULL, email varchar(255) default NULL,  url text, IP text NOT NULL, title varchar(255) default NULL, lastcmt datetime NOT NULL default '0000-00-00 00:00:00', adult tinyint(2) NOT NULL default '0', edittime int(20) unsigned default NULL, animation tinyint(2) default '0', datatype tinyint(2) default '0', archive tinyint(2) NOT NULL default '0', postlock tinyint(4) NOT NULL default '0', ";

			// OekakiData v1.1.0
			$sql .= "threadlock TINYINT NOT NULL DEFAULT 0, px MEDIUMINT DEFAULT 0, py MEDIUMINT DEFAULT 0, ptype VARCHAR(4), ttype VARCHAR(4), rtype VARCHAR(4), usethumb TINYINT NOT NULL DEFAULT 0, ";
			$sql .= "PRIMARY KEY (ID_2), UNIQUE KEY PIC_ID (PIC_ID))";

			$result = mysql_query($sql);
			sql_check($result, 'data');
		}

		$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakionline (OID BIGINT(255) NOT NULL auto_increment, onlineusr varchar(100) NOT NULL default '', onlinetime timestamp(14) NOT NULL, onlineIP text NOT NULL, locale varchar(30) default NULL, onlineboard text NOT NULL, PRIMARY KEY  (OID), UNIQUE KEY onlineusr (onlineusr))");
		sql_check($result, 'online');

		$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakimailbox (MID int(11) NOT NULL auto_increment, sender varchar(255) NOT NULL default '', reciever varchar(255) NOT NULL default '', subject text NOT NULL, body longtext NOT NULL, mstatus smallint(10) NOT NULL default '0', senddate datetime NOT NULL default '0000-00-00 00:00:00', PRIMARY KEY (MID), KEY sender(sender), KEY reciever (reciever))"); 
		sql_check($result, 'mailbox');

		$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakikill (KID tinyint(4) NOT NULL auto_increment, lastkill date NOT NULL default '0000-00-00', PRIMARY KEY (KID),  KEY lastkill (lastkill))");
		sql_check($result, 'kill_crate');

		$result = mysql_query("INSERT INTO ".$OekakiPoteto_MemberPrefix."oekakikill (KID, lastkill) VALUES ('',CURDATE())");
		sql_check($result, 'kill_set');

		$result = mysql_query("CREATE TABLE ".$OekakiPoteto_Prefix."oekakimisc (MiscID int(11) NOT NULL auto_increment, miscname varchar(255) NOT NULL default '', miscvalue bigint(255) default '0' NOT NULL, miscstring VARCHAR(14), PRIMARY KEY (MiscID), KEY miscname (miscname))");
		sql_check($result, 'misc');

		$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakichatmod (usrname varchar(255) NOT NULL default '',  command varchar(32) NOT NULL default 'MESSAGE', comment tinytext NOT NULL, posttime timestamp(14) NOT NULL, hostname text NOT NULL, email varchar(255) default NULL, url text,  IP text NOT NULL, postname varchar(50) NOT NULL default '', PRIMARY KEY (posttime)) TYPE=MyISAM;"); 
		sql_check($result, 'chat_mod');

		$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakichatmodusers (usrname varchar(255) NOT NULL,  lastmessage timestamp(14) NOT NULL, afk ENUM('no','yes') NOT NULL default 'no', PRIMARY KEY (usrname)) TYPE=MyISAM;");
		sql_check($result, 'chat_mod_users');

		$result = mysql_query("INSERT INTO ".$OekakiPoteto_Prefix."oekakimisc VALUES (1,'piccount','$resno',NULL)");
		sql_check($result, 'piccount');
		$result = mysql_query("INSERT INTO ".$OekakiPoteto_Prefix."oekakimisc VALUES (2,'dbversion',0,'wac-1.1.0')");
		sql_check($result, 'dbversion');
	}

	mysql_close($dbconn);

	web_line('Finished setting up database...');

echo <<<EOF
		</p>
		<hr />

		<p class="infonote">
			If you did not recieve any errors, the databases have been installed.<br />
			<br />
			If you are installing another board and your primary board is functioning properly, ignore any database errors.<br />
			<br />
			Click the button below to finalize the installation.  This will clean up the installer files and prevent security problems.  You will have to copy <em>install.php</em> into the Oekaki Poteto folder if you need to uninstall the database.  All other maintenance can be done with the control panel.
		</p>

		<form action="index.php" method="post">
			<input name="action" type="hidden" value="secure" />
			<input name="submit" type="submit" value="Secure installer and go to the BBS" />
		</form>
	</div>

</body>
</html>
EOF;
//<?

	exit;
}


// No mode specified.  Output installer.
//
echo <<<EOF
	<h1 class="title">
		Wacintaki Poteto Installation
	</h1>

	<hr />


	<form name="form2" method="post" action="install.php">
		<h2 class="header">
			Select Your Default Language
		</h2>

		<div class="infotable">
			<select name="language">

EOF;
//<?

if ($handle = opendir('language')) {
	/* This is the correct way to loop over the directory. */
	while (false !== ($file = readdir($handle))) {
		if(substr($file,-4) == '.php'){
?>
			<option value="<?=substr($file,0,-4)?>"<? if($inst_language.'.php' == $file) echo ' selected'; ?>><?=substr($file,0,-4)?></option>
<?
		}
	}
	closedir($handle);
}

echo <<<EOF
			</select>

			<p>
				<input name="langsel" type="submit" id="langsel" value="Submit" />
			<p>
		</div>
	</form>
	<br />



	<form name="form1" method="post" action="install.php">
		<h2 class="header">
			$langop_install_information
		</h2>

		<div class="infotable">
			<p class="infonote">
				$langop_install_disclaimer
			</p>

			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbhostname
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="dbhost" size="40" style="font-color:red;" value="localhost" />
			</td>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbname
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="dbname" size="40" value="$dbname" />
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbusername
			</td>
			<td>
				<input type="text" name="dbuser" size="40" value="$dbuser" />
			<td class="infoenter" valign="top">
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_dbpass
			</td>
			<td class="infoenter" valign="top">
				<input type="password" name="dbpass" size="40" />
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_prefix
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="dbprefix" size="40" value="op_" />

				<p class="subtext">
					$langop_install_prefixsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_mdbprefix
			</td>
			<td class="infoenter" valign="top">
				<input name="OekakiPoteto_MemberPrefix" type="text" id="OekakiPoteto_MemberPrefix" value="op_" size="40" />

				<p class="subtext">
					If you are trying to install multiple boards using one user database, make sure all other OP board databases that you want to use under one account have the same prefix, otherwise, leave this value alone.  <strong>Note that if you share a member database, uninstalling ANY board will remove all member profiles for all boards!</strong>
				</p>
			</td>
			</tr>
			</table>

			<p class="infonote" style="text-align: center">
				Click here to <a href="install.php?language=$url_language&amp;mode=del">uninstall an existing database</a>.  Confirmation will be requested.
			</p>
		</div>
		<br />



		<h2 class="header">
			$langop_install_dispreg
		</h2>

		<div class="infotable">
			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				$langop_install_opurl
			</td>
			<td class="infoenter" valign="top">
				<input name="okurl" type="text" value="http://" size="40" />
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_email
			</td>
			<td class="infoenter" valign="top">
				<input name="eaddr" type="text" size="40" />

				<p class="subtext">
					$langop_install_emailsub
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_general
		</h2>

		<div class="infotable">
			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				$langop_install_salt
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="saltstr" size="40" value="As" />

				<p class="subtext">
					$langop_install_saltsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Picture Name Prefix
			</td>
			<td class="infoenter" valign="top">
				<input name="OPPrefix" type="text" value="OP_" size="40" />

				<p class="subtext">
					This prefix will appear on every picture and animation saved by the BBS.  Example: "OP_50.png"
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_picdir
			</td>
			<td class="infoenter" valign="top">
				<input name="OPpics" type="text" value="pictures" size="40" />

				<p class="subtext">
					$langop_install_picdirsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_picstore
			</td>
			<td class="infoenter" valign="top">
				<input name="pstore" type="text" value="200" size="40" />

				<p class="subtext">
					$langop_install_picstoresub
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_reg
		</h2>

		<div class="infotable">
			<table>
			<tr>
			<td class="infoask" valign="top">
				$langop_install_adel
			</td>
			<td class="infoenter" valign="top">
				<input name="killuser" type="text" value="-1" size="6" />
				$langop_install_adelsub2

				<p class="subtext">
					$langop_install_adelsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Show Rules Before Registration
			</td>
			<td class="infoenter" valign="top">
				<select name="use_reg_rules" class="multiline">
					<option value="yes">$langop_word_yes</option>
					<option value="no" selected>$langop_word_no</option>
				</select>

				<p class="subtext">
					If yes, people will be shown the rules before they can submit a new registration.  Use &ldquo;Edit Rules&rdquo; in the admin menu to set rules.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_gallow
			</td>
			<td class="infoenter" valign="top">
				<select name="guestpost">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>

				<p class="subtext">
					$langop_install_gallowsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Require Art -->
			<tr>
			<td class="infoask" valign="top">
				Require Art Submission
			</td>
			<td class="infoenter" valign="top">
				<select name="requireart">
					<option value="yes">$langop_word_yes</option>
					<option value="no" selected>$langop_word_no</option>
				</select>

				<p class="subtext">
					If yes, new users are instructed to provide a link to a piece of art for the administrator to view.<br />
					If no, new users are told the URL field is optional.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_rapproval
			</td>
			<td class="infoenter" valign="top">
				<select name="approval">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
					<option value="force">No (forced)</option>
				</select>

				<p class="subtext">
					If yes, approval by the administrators is required to register.<br />
					If no, users will recieve an activation code in their e-mail.
					<b>Use &ldquo;forced&rdquo; ONLY if your server cannot send e-mails, and you want automatic approval.</b>
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Default Permissions for Approved Registrations
			</td>
			<td class="infoenter" valign="top">
				<input name="drawaccess" type="checkbox" value="D" checked />Draw Access<br />
				<input name="animationaccess" type="checkbox" value="A" checked />Animation Access<br />
				<input name="uploadaccess" type="checkbox" value="U" />Upload Access
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_dispgen
		</h2>

		<div class="infotable">
			<table class="infomain">

			<!-- BBS Title -->
			<tr>
			<td class="infoask" valign="top">
				$langop_install_title2
			</td>
			<td class="infoenter" valign="top">
				<input name="BBStitle" type="text" value="OekakiPoteto BBS" size="40" />

				<p class="subtext">
					$langop_install_title2sub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- BBS Author -->
			<tr>
			<td class="infoask" valign="top">
				Author Name
			</td>
			<td class="infoenter" valign="top">
				<input name="BBSauthor" type="text" value="" size="40" />

				<p class="subtext">
					Name of the BBS owner.  This is displayed in the copyright and page metadata.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Adult rated BBS
			</td>
			<td class="infoenter" valign="top">
				<select name="BBSadult">
					<option value="yes">Yes</option>
					<option value="no" selected>No</option>
				</select>
				<br />

				<p class="subtext">
					Select Yes to declare your BBS for adults only.  Users are required to state their age to register.<br />
					NOTE:  Does <strong>not</strong> make every picture adult by default.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				Allow guests access to pr0n
			</td>
			<td class="infoenter" valign="top">
				<select name="guestadult" id="animationaccess" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>

				<p class="subtext">
					If yes, adult images are blocked and may be viewed by clicking the pr0n placeholder.<br />
					If no, the link is disabled and all access is blocked.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_deftem
			</td>
			<td class="infoenter" valign="top">
				<select name="template" id="template">

EOF;
//<?

if ($handle = opendir('templates')) {
	/* This is the correct way to loop over the directory. */
	while (false !== ($file = readdir($handle))) {
		if (substr($file,-4) == '.php'){
			if (strtolower(substr($file,0,-4)) == 'banana') {
?>
				<option value="<?=substr($file,0,-4)?>" selected><?= substr($file, 0, -4); ?></option>
<?
			} else {
?>
				<option value="<?=substr($file,0,-4)?>"><?= substr($file, 0, -4); ?></option>
<?
			}
		}
	}
	closedir($handle);
}

echo <<<EOF
				</select>

				<p class="subtext">
					$langop_install_deftemsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pictures per index page -->
			<tr>
			<td class="infoask" valign="top">
				Number of Pics on Index
			</td>
			<td class="infoenter" valign="top">
				<input name="ppage" type="text" value="10" size="40" />

				<p class="subtext">
					Number of pictures to display per page of the BBS
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pictures per other page -->
			<tr>
			<td class="infoask" valign="top">
				Number of Entries on Menus
			</td>
			<td class="infoenter" valign="top">
				<input name="perpage" type="text" value="25" size="40" />

				<p class="subtext">
					Number of entries (such as user names) to display per page of the menus and admin controls
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_appletset
		</h2>

		<div class="infotable">
			<table class="infomain">
			<!-- Canvas Defaults -->
			<tr>
			<td class="infoask" valign="top">
				Default Canvas Size
			</td>
			<td class="infoenter" valign="top">
				<input name="xDefault" type="text" value="300" size="6" />
				&times;
				<input name="yDefault" type="text" value="300" size="6" />

				<p class="subtext">
					The default canvas size.  Typical value is 300 &times; 300 pixels
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Canvas Min -->
			<tr>
			<td class="infoask" valign="top">
				Minimum Canvas Size
			</td>
			<td class="infoenter" valign="top">
				<input name="xMin" type="text" value="50" size="6" />
				&times;
				<input name="yMin" type="text" value="50" size="6" />

				<p class="subtext">
					The minimum canvas size.  Recommended minimum is 50 &times; 50 pixels
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Canvas Max -->
			<tr>
			<td class="infoask" valign="top">
				Maximum Canvas Size
			</td>
			<td class="infoenter" valign="top">
				<input name="xCanvas" type="text" value="500" size="6" />
				&times;
				<input name="yCanvas" type="text" value="500" size="6" />

				<p class="subtext">
					Maximum canvas.  Recommended maximum is 500 &times; 500 pixels.<br />
					Be aware that a small increase in dimentions results in a large increase in surface area, and thus filesize and bandwidth.  1000 &times; 1000 uses <strong>four times</strong> as much bandwidth as 500 &times; 500!
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Max Anim -->
			<tr>
			<td class="infoask" valign="top">
				$langop_install_animax
			</td>
			<td class="infoenter" valign="top">
				<input name="anisize" type="text" value="500000" size="40" />
				$langop_install_bytes

				<p class="subtext">
					$langop_install_animaxsub
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Max Upload -->
			<tr>
			<td class="infoask" valign="top">
				Maximum Upload Filesize
			</td>
			<td class="infoenter" valign="top">
				<input name="max_upload" type="text" value="500000" size="40" class="txtinput" />
				$langop_install_bytes

				<p class="subtext">
					The max filesize uploaded pictures can be, in bytes.  Default is 500,000 bytes or 500KB.<br />
					Maximum is 2,000,000 bytes or 2MB, the maximum value allowed for most servers.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Max Area
			<tr>
			<td class="infoask" valign="top">
				Maximum Canvas Area
			</td>
			<td class="infoenter" valign="top">
				<input name="aCanvas" type="text" value="250000" size="40" />

				<p class="subtext">
					This setting allows for large, panoramic canvases without affecting bandwidth.  Example: 1000 &times; 250 uses the same bandwidth as 500 &times 500, while allowing the max width and height to be 1000 pixels each.  However, a 1000 &times 1000 canvas would not be allowed.  Default is 250000 pixels.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>
			-->
			<input name="aCanvas" type="hidden" value="250000" />



			<!-- Preview -->
			<tr>
			<td class="infoask" valign="top">
				Canvas size preview
			</td>
			<td class="infoenter" valign="top">
				<input name="previewImg" type="text" value="preview.png" size="40" />

				<p class="subtext">
					Image for canvas size preview on Draw screen.  Square picture recommended.
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Preview Title -->
			<tr>
			<td class="infoask" valign="top">
				Preview Title
			</td>
			<td class="infoenter" valign="top">
				<input name="previewTitle" type="text" value="Image Preview" size="40" />

				<p class="subtext">
					Title of preview image (Text only &amp; do not use double quotes).
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Pr0n Image -->
			<tr>
			<td class="infoask" valign="top">
				&ldquo;Pr0n&rdquo; placeholder image
			</td>
			<td class="infoenter" valign="top">
				<input name="pornImg" type="text" value="pr0n.png" size="40" class="txtinput" />

				<p class="subtext">
					Image for substitution of pr0n.  Square picture recommended.  Default &ldquo;pr0n.png&rdquo;
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Mailbox -->
		<h2 class="header">
			Display - $langop_word_mailbox
		</h2>

		<div class="infotable">
			<table class="infomain">

			<!-- Enable Mailbox -->
			<tr>
			<td class="infoask" valign="top">
				Enable $langop_word_mailbox
			</td>
			<td class="infoenter" valign="top">
				<select name="useMailbox" class="txtinput">
					<option value="yes" selected>$langop_word_yes (recommended)</option>
					<option value="no">$langop_word_no</option>
				</select>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_dispchat
		</h2>

		<div class="infotable">
			<table class="infomain">

			<tr>
			<td class="infoask" valign="top">
				Enable Chat
			</td>
			<td class="infoenter" valign="top">
				<select name="useChat">
					<option value="no" selected>$langop_word_no (recommended)</option>
					<option value="yes">$langop_word_yes</option>
				</select>

				<p class="subtext">
					Note:  chat uses a lot of bandwidth
				</p>
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>

			<tr>
			<td class="infoask" valign="top">
				$langop_install_displinesmax
			</td>
			<td class="infoenter" valign="top">
				<input name="chatMax" type="text" value="1000" size="40" />
			</td>
			</tr>

			<tr><td colspan="2">&nbsp;</td></tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_displines
			</td>
			<td class="infoenter" valign="top">
				<input name="chatDisp" type="text" value="15" size="40" />
			</td>
			</tr>
			</table>
		</div>
		<br />



		<!-- Compression Settings -->
		<h2 class="header">
			$langop_compress_title
		</h2>

		<div class="infotable">
			<p class="infonote">

EOF;
if (!extension_loaded ('gd')) {
echo <<<EOF
				Your server does not have the graphics system &ldquo;GDlib&rdquo; installed, therefore you cannot enable thumbnail support.  However, you may still select a default thumbnail mode which will conserve screenspace by shrinking pictures.<br />
				<br />

EOF;
}
echo <<<EOF
				Four thumbnail modes are available.  None, Layout, Scaled, and Uniformity.  If you're confused which mode to use, try Scaled first.<br />
				<br />
				<strong>None</strong> will disable thumbnail/layout support, and will use a lot of bandwidth.  <strong>Layout</strong> will keep pictures their original sizes unless they use too much bandwidth, and then a thumbnail is used.  <strong>Scaled Layout</strong> is identical to Layout except very large pictures are scaled to fit the screen.  <strong>Uniformity</strong> makes all the pictures the same size with a tiny thumbnail.<br />
				<br />
				If you choose &ldquo;None&rdquo;, thumbnail support will always be off for all members unless you enable it later in the control panel.
			</p>

			<table class="infomain">
			<!-- Layout mode -->
			<tr>
			<td class="infoask" valign="top">
				Default thumbnail mode
			</td>
			<td class="infoenter" valign="top">
				<select name="useThumb" class="multiline">
					<option value="0">None</option>
					<option value="1">Layout</option>
					<option value="2" selected>Scaled (default)</option>
					<option value="3">Uniformity</option>
				</select>

				<p class="subtext">
					Tip:  Options are ordered in terms of bandwidth.  Uniformity uses the least bandwidth.  Scaled Layout is recommended.
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Force Layout -->
			<tr>
			<td class="infoask" valign="top">
				 Force default thumbnails
			</td>
			<td class="infoenter" valign="top">
				<select name="forceThumb" class="multiline">
					<option value="yes" selected>$langop_word_yes</option>
					<option value="no">$langop_word_no</option>
				</select>

				<p class="subtext">
					If yes, users may only use the default mode (recommended for servers with little bandwidth). If no, users may select any thumbnail mode they wish.
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Small Thumbnail Size -->
			<tr>
			<td class="infoask" valign="top">
				Small thumbnail size
			</td>
			<td class="infoenter" valign="top">
				<input name="thumbT" type="text" value="120" size="10" class="txtinput" />

				<p class="subtext">
					Size of small (uniformity) thumbnails in pixels.  Small thumbnails are generated often.  Default 120.
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Large Thumbnail Size -->
			<tr>
			<td class="infoask" valign="top">
				Large thumbnail size
			</td>
			<td class="infoenter" valign="top">
				<input name="thumbR" type="text" value="250" size="10" class="txtinput" />

				<p class="subtext">
					Size of large (layout) thumbnails.  Large thumbnails are made only occasionally for layout or scaled thumbnail modes.  Default 250.
				</p>
			</td>
			</tr>


			<tr><td colspan="2">&nbsp;</td></tr>


			<!-- Thumbnail Bytes -->
			<tr>
			<td class="infoask" valign="top">
				Filesize for large thumbnail generation
			</td>
			<td class="infoenter" valign="top">
				<input name="thumbBytes" type="text" value="100000" size="10" class="txtinput" />
				<?=$langop_install_bytes?> 

				<p class="subtext">
					If a picture's filesize is greater than this value, a large thumbnail will be generated in addition to the small one.  Default is 100,000 bytes.  If using uniformity mode only, set to zero to disable and save server space.
				</p>
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			$langop_install_admininfo
		</h2>

		<div class="infotable">
			<p class="infonote">
				<strong>$langop_install_TOS</strong>
			</p>

			<table class="infomain">
			<tr>
			<td class="infoask" valign="top">
				$langop_install_login
			</td>
			<td class="infoenter" valign="top">
				<input type="text" name="usrname" size="40" value="$usrname" />
			</td>
			</tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_install_password
			</td>
			<td class="infoenter" valign="top">
				<input type="password" name="pass" size="40" />
			</td>
			</tr>


			<tr>
			<td class="infoask" valign="top">
				$langop_eprofile_repass
			</td>
			<td class="infoenter" valign="top">
				<input type="password" name="pass2" size="40" />
			</td>
			</tr>
			</table>
		</div>
		<br />



		<h2 class="header">
			Submit Information for Install
		</h2>

		<div class="infotable">
			<p style="text-align: center;">
				<input type="submit" name="Submit" value="Submit" />
				<input name="languagesel" type="hidden" value="$url_language" />
			</p>
		</div>
	</form>
	<br />


	<div id="footer">
		OekakiPoteto 5.x by <a href="http://www.suteki.nu">RanmaGuy</a> and <a href="http://www.cellosoft.com">Marcello</a><br />
		Wacintaki Poteto 1.x modifications by <a href="http://www.NineChime.com/Wacintosh.htm">Waccoon</a>
	</div>

</body>
</html>
EOF;
//<?

exit();
?>